//
//  FlutterSurfaceView.m
//  rtm_flutter_plugin
//
//  Created by 王俨 on 2020/8/9.
//

#import "FlutterSurfaceView.h"
#import <LinkV/LinkV.h>


@interface FlutterSurfaceView ()

@property (nonatomic, strong) LVRTCDisplayView *displayView;


@end

@implementation FlutterSurfaceView


- (instancetype)initWithFrame:(CGRect)frame
               viewIdentifier:(int64_t)viewId
                    arguments:(id _Nullable)args {
    if (self = [super init]) {
        
//        if (![args isKindOfClass:[NSDictionary class]]) return self;
//        NSDictionary *dict = [self removeNull:args];
//        LVRTMEngine *engin = [LVRTMEngine shared];
//
//        NSString *uid = dict[@"uid"];
//        BOOL isLocalPreview = [dict[@"isLocalPreview"] boolValue];
//
//        self.containerView = [UIView new];
//
//        if (isLocalPreview) {
//            [engin startPreview:self.containerView];
//        } else {
//            [engin startPlayingStream:uid inView:self.containerView];
//        }
        
        self.displayView = [LVRTCDisplayView new];
        self.displayView.viewContentMode = LVViewContentModeScaleAspectFill;
        
        BOOL isMaster = NO;
        if ([args isKindOfClass:[NSDictionary class]]) {
            NSDictionary *dict = args;
            
            if ([dict[@"isLocalPreview"] isKindOfClass:[NSNull class]] || [dict[@"uid"] isKindOfClass:[NSNull class]]) {
                return self;
            };
            
            isMaster = [dict[@"isLocalPreview"] boolValue];
            NSString *uid = dict[@"uid"];
            if (!isMaster) {
                self.displayView.uid = uid;
            }
            self.displayView.isLocal = isMaster;
        }
        
        [[LVRTCEngine sharedInstance] addDisplayView:self.displayView];
        
        if (isMaster) {
            [[LVRTCEngine sharedInstance] startCapture];
        }
    }
    
    return self;
}

- (UIView *)view {
    return self.displayView;
}

#pragma mark - dealloc
- (void)dealloc {
    NSLog(@"♻️ Dealloc %@", NSStringFromClass([self class]));
}

#pragma mark - private
- (NSDictionary *)removeNull:(NSDictionary *)dict {
    NSArray *allKeys = dict.allKeys;
    
    NSMutableDictionary *dictM = [dict mutableCopy];
    for (NSString *key in allKeys) {
        if ([dict[key] isKindOfClass:[NSNull class]]) {
            [dictM removeObjectForKey:key];
        }
    }
    
    return dictM;
}

@end
