//
//  LVIMFileContent.h
//  CMIMLib
//
//  Created by 鹿容 on 2021/9/23.
//  Copyright © 2021 cmcm. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "LVIMEnumDefine.h"
#import "LVIMEnumDefine.h"

NS_ASSUME_NONNULL_BEGIN
@class LVIMFileContent;
//文件实体
@interface LVIMFileContent : NSObject
//文件在云端存储的key值
@property (nonatomic,copy,readonly)NSString *key;
//本地地址
@property (nonatomic,copy,readonly)NSString *localPath;
//文件大小
@property (nonatomic,assign,readonly)long long fileLength;
//文件后缀
@property (nonatomic,copy,readonly)NSString *pathExtension;
//文件类型
@property (nonatomic,assign,readonly)LVIM_MEDIA_FILE_TYPE filetype;

-(NSDictionary *)dictionary;

/**
 @brief 下载资源,下载成功后,会自动给localPath赋值
 **/
-(void)downloadFileWithProgress:(LVIM_PROGRESS_CALLBACK)progressCallback complete:(LVIM_DOWNLOAD_CALLBACK)downloadCallback;
/**
 @brief 上传资源,成功后key自动赋值
 **/
-(void)uploadFileWithProgress:(LVIM_PROGRESS_CALLBACK)progressCallback complete:(LVIM_DOWNLOAD_CALLBACK)downloadCallback;
/**
 @brief 通过文件路径初始化,大型文件建议通过该函数初始化
 上传成功后会拷贝至SDK沙盒目录
 **/
-(instancetype)initWithPath:(NSString *)path fileType:(LVIM_MEDIA_FILE_TYPE)filetype;

/**
 @brief 通过云端的key初始化
 下载成功后,会自动给localPath赋值
 **/
-(instancetype)initWithKey:(NSString *)key fileType:(LVIM_MEDIA_FILE_TYPE)filetype pathExtension:(NSString *)pathExtension;

@end

NS_ASSUME_NONNULL_END
