import 'package:linkv_rtc_im/bean/lv_im_msg.dart';

import 'linkv_api_defines.dart';

class LinkVVideoCallback {
  /// 有成员加入的通知
  /// @param userId 用户ID
  void onAddRemoter(String userId) {}

  /// 有成员离开的通知
  /// @param uid 离开用户 ID
  void onDeleteRemoter(String uid) {}

  /// 房间断开的通知
  /// @param code 错误码
  void onRoomDisconnect(int code) {}

  /// 房间重连成功通知，SDK 在网络断开和恢复时会自动进行重连，重连结果通过该回调通知 APP
  void onRoomReconnect() {}

  /// 房间连接成功
  void onRoomConnected() {}

  /// 发布资源质量状态变化的通知，SDK 内部会定时统计推流的质量信息，APP 可以实现该方法获取推流的视频质量信息统计，回调的频率可以通过 +setPublishQualityMonitorCycle 进行设置
  /// @param lvVideoStatistic 质量信息
  void onPublishQualityUpdate(LVVideoStatistic lvVideoStatistic) {}

  /// 发布资源状态变更的通知，调用 startPublishing 之后会触发该方法回调，发布资源状态的变更会通过该方法进行通知
  /// @param code 状态码
  void onPublishStateUpdate(int code) {}

  /// 播放质量变化的通知，SDK 内部会定时统计拉流质量信息，APP 可以实现该方法获取拉流的视频质量信息统计，回调的频率可以通过 +setPlayQualityMonitorCycle 进行设置
  /// @param lvVideoStatistic 质量信息
  /// @param uid 用户 ID
  void onPlayQualityUpdate(LVVideoStatistic lvVideoStatistic, String uid) {}

  /// 播放状态变化的通知，调用 startPlayingStream: 方法之后，播放状态的变更会通过该方法进行通知
  /// @param code 状态码
  /// @param uid 用户 ID
  void onPlayStateUpdate(int code, String uid) {}

  /// 视频宽高变化
  void onVideoSizeChanged(String streamID, int width, int height) {}

  /// 收到房间消息
  /// @param msg 收到的消息模型
  void onRoomMessageReceive(var msg) {}

  /// 房间某用户开启或关闭摄像头
  /// @param userId 用户的ID
  /// @param enable 是否开启摄像头
  void onUserEnableVideo(String userId, bool enable) {}

}
